package contents

type Option interface {
	KeyValue() [2]string
}

type CharSet string
const (
	Utf8 CharSet = "utf-8"
)
func (cs CharSet) KeyValue() [2]string {
	return [2]string{
		"charset",
		string(cs),
	}
}

type Type string
const (
	// Using the UTF-8 by default.
	Unknown Type = "application/octet-stream"
	Binary
	Plain= "text/plain"
	Css= "text/css"
	Html= "text/html"
	Json= "application/json"
	UrlEncoded= "application/x-www-form-urlencoded"
)

